local function comma_value(n)
    local left,num,right = string.match(n,'^([^%d]*%d)(%d*)(.-)$')
    return left..(num:reverse():gsub('(%d%d%d)','%1,'):reverse())..right
end

local function round(number)
    if (number - (number % 0.1)) - (number - (number % 1)) < 0.5 then
        number = number - (number % 1)
    else
        number = (number - (number % 1)) + 1
    end
    return number
end

local orig_do_action_melee = PlayerStandard._do_action_melee
function PlayerStandard:_do_action_melee(t, ...)
   orig_do_action_melee(self, t, ...)
   for _,unit in pairs(World:find_units_quick("all", 1)) do
        local timer = unit:base() and unit:timer_gui() and unit:timer_gui()._current_timer
        if timer and math.floor(timer) ~= -1 then
            local newvalue = timer - 5
            unit:timer_gui():_start(newvalue)
            if managers.network:session() then
                managers.network:session():send_to_peers_synched("start_timer_gui", unit:timer_gui()._unit, newvalue)
            end
            if not unit:timer_gui()._jammed then
                unit:timer_gui():set_jammed(true)
            end
            if unit:timer_gui()._jammed then
                unit:timer_gui():set_jammed(false)
            end
            
            local calc = managers.money:total() - (500 * newvalue)
            managers.money:_set_total(calc)
            managers.hud:show_hint({text = string.format("Time cost: %s$ / %s$", comma_value(round((500 * newvalue))), comma_value(round(calc))), time = 3})
        end
    end
end